---
layout: default
title: "CameraView v2"
---

# CameraView

CameraView is a well documented, high-level library that makes capturing pictures and videos easy,
addressing most of the common issues and needs, and still leaving you with flexibility where needed.

- Fast & reliable
- Gestures support
- Frame processing support
- OpenGL powered preview
- Take high-quality content with `takePicture` and `takeVideo`
- Take super-fast snapshots with `takePictureSnapshot` and `takeVideoSnapshot`
- Smart sizing: create a `CameraView` of any size
- Control HDR, flash, zoom, white balance, exposure, location, grid drawing & more
- Lightweight: the only dep. is support `ExifInterface`
- Works down to API level 15
- Well tested

<p align="center">
  <img src="static/icon.png" vspace="10" width="200" height="200">
</p>

### Get started

Get started with [install info](about/install.html), [quick setup](about/getting-started.html), or
read the in-depth [documentation](docs/camera-events.html).

### Older versions

This website contains documentation and informations about version 2.X.X of the library.
For older versions, please take a look at the v1 branch in the [project page](https://github.com/natario1/CameraView).
For migration guide, take a look at the [migration page](extra/v1-migration-guide.html).

### Support

If you like the project, use it with profit, and want to thank back, please consider [donating or
becoming a supporter](extra/donate.html).

